function [D] = calctensorfromsig(sig,sig0,bval,direc,ROI)
%Calculates the tensor for a directional dataset and returns it on
%vectorform as a 6xnxm.
[n m p] = size(sig);

%Unrollls the direction matrix to a px6 vector
A = zeros(p,6);
for i = 1:p
   tmp = direc(i,:)'*direc(i,:);
   A(i,:) = [tmp(1,1) tmp(2,2), tmp(3,3) 2*tmp(1,2) 2*tmp(1,3), 2*tmp(2,3)];
end

%calculates the tensor
D = zeros(6,n,m);
for x = 1:n
    for y = 1:m
        if ROI(x,y) == 1
                         % -------equivalent to ADC------------------------
            D(:,x,y) = -A\(log(squeeze(sig(x,y,:))./squeeze(sig0(x,y,:)))/bval);
        else
            D(:,x,y) = zeros(6,1);
        end
    end
end

